{
  "x-generator": "On Key REST API Docs Generator",
  "swagger": "2.0",
  "info": {
    "title": "On Key DM  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "host": "<variable>:443",
  "basePath": "/api/tenants/{client}/{connection}",
  "schemes": [
    "https"
  ],
  "consumes": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.entitypatch+json",
    "application/vnd.onkey.entitydelete+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.entitypatchcollection+json",
    "application/vnd.onkey.entitydeletecollection+json",
    "multipart/form-data"
  ],
  "produces": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.notification+json",
    "application/vnd.onkey.entitycollectionpage+json",
    "application/vnd.onkey.entitycollection+json",
    "*/*"
  ],
  "paths": {
    "/Modules/DM/DocumentFolders/{id}": {
      "get": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Get a Document Folder resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | DocumentFolder->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | DocumentFolder->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | DocumentFolder->CreatedByUser_FullName | string |  |\r\n| createdOn | DocumentFolder->CreatedOn | string | date-time |\r\n| modifiedByUserId | DocumentFolder->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | DocumentFolder->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | DocumentFolder->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | DocumentFolder->ModifiedOn | string | date-time |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| description | DocumentFolder->Description | string |  |\r\n| notes | DocumentFolder->Notes | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| parentDocumentFolderDescription | DocumentFolder->ParentDocumentFolder_Description | string |  |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n",
        "operationId": "GetDocumentFolder",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Folder Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Folder",
            "schema": {
              "$ref": "#/definitions/GetDocumentFolderResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Update an existing Document Folder resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n| description | DocumentFolder->Description | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n| notes | DocumentFolder->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n\r\n",
        "operationId": "UpdateDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Folder Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateDocumentFolderResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Folder was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Delete an existing Document Folder resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Folder Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "input",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteDocumentFolderResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Folder was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentFolders": {
      "get": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Get a collection of Document Folder resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| description | DocumentFolder->Description | string |  |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| parentDocumentFolderDescription | DocumentFolder->ParentDocumentFolder_Description | string |  |\r\n",
        "operationId": "GetDocumentFolderCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Document Folder collection",
            "schema": {
              "$ref": "#/definitions/GetDocumentFolderCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Create a new Document Folder resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| description | DocumentFolder->Description | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n| notes | DocumentFolder->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n\r\n",
        "operationId": "CreateDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateDocumentFolderResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentFolders/Lookups/LookupDocumentFolderParentDocumentFolder": {
      "get": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Lookup the Document Folder for the Document Folder.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| description | DocumentFolder->Description | string |  |\r\n",
        "operationId": "LookupDocumentFolderParentDocumentFolder",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Document Folder collection",
            "schema": {
              "$ref": "#/definitions/DocumentFolderParentDocumentFolderLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentFolders/Batch/{ids}": {
      "get": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Get a collection of Document Folder resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | DocumentFolder->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | DocumentFolder->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | DocumentFolder->CreatedByUser_FullName | string |  |\r\n| createdOn | DocumentFolder->CreatedOn | string | date-time |\r\n| modifiedByUserId | DocumentFolder->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | DocumentFolder->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | DocumentFolder->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | DocumentFolder->ModifiedOn | string | date-time |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| description | DocumentFolder->Description | string |  |\r\n| notes | DocumentFolder->Notes | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| parentDocumentFolderDescription | DocumentFolder->ParentDocumentFolder_Description | string |  |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n",
        "operationId": "BatchGetDocumentFolder",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Document Folder id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Folder collection",
            "schema": {
              "$ref": "#/definitions/BatchGetDocumentFolderResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentFolders/Batch": {
      "post": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Create a new collection of Document Folder resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| description | DocumentFolder->Description | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n| notes | DocumentFolder->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n\r\n",
        "operationId": "BatchCreateDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateDocumentFolderRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Document Folder batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Update a collection of existing Document Folder resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n| description | DocumentFolder->Description | string |  |\r\n| parentDocumentFolderId | DocumentFolder->ParentDocumentFolder_Id | integer | int64 |\r\n| sequenceNumber | DocumentFolder->SequenceNumber | integer | int32 |\r\n| notes | DocumentFolder->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n\r\n",
        "operationId": "BatchUpdateDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateDocumentFolderResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Folder batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Document Folder"
        ],
        "summary": "Delete a collection of existing Document Folder resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| version | DocumentFolder->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteDocumentFolder",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteDocumentFolderResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Folder batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/DownloadFile": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Download the content for a Document Record resource.",
        "description": "",
        "operationId": "GetDocumentRecordFile",
        "produces": [
          "*/*",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "format": "int64",
            "x-nullable": false
          },
          {
            "type": "integer",
            "name": "cv",
            "in": "query",
            "description": "Return older version of file content",
            "format": "int32",
            "x-nullable": true
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains file content",
            "schema": {
              "type": "string",
              "format": "binary"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Get a Document Record resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | DocumentRecord->Code | string |  |\r\n| isActive | DocumentRecord->IsActive | boolean |  |\r\n| createdByUserId | DocumentRecord->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | DocumentRecord->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | DocumentRecord->CreatedByUser_FullName | string |  |\r\n| createdOn | DocumentRecord->CreatedOn | string | date-time |\r\n| modifiedByUserId | DocumentRecord->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | DocumentRecord->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | DocumentRecord->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | DocumentRecord->ModifiedOn | string | date-time |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | DocumentRecord->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | DocumentRecord->PermissionTree_Description | string |  |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| approvedByUserId | DocumentRecord->ApprovedByUser_Id | integer | int64 |\r\n| approvedByUserCode | DocumentRecord->ApprovedByUser_Code | string |  |\r\n| approvedByUserFullName | DocumentRecord->ApprovedByUser_FullName | string |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| description | DocumentRecord->Description | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| documentFolderDescription | DocumentRecord->DocumentFolder_Description | string |  |\r\n| contentId | DocumentRecord->Content_Id | integer | int64 |\r\n| contentFileLocationId | DocumentRecord->Content_FileLocation_Id | integer | int64 |\r\n| contentFileLocationDescription | DocumentRecord->Content_FileLocation_Description | string |  |\r\n| contentFileLocationFileLocationType | DocumentRecord->Content_FileLocation_FileLocationType | string (Allowed values: [FileSystem, Database]) | enum |\r\n| contentFileLocationOnKeyFileStoreId | DocumentRecord->Content_FileLocation_OnKeyFileStoreId | string | uuid |\r\n| contentSizeInBytes | DocumentRecord->Content_SizeInBytes | integer | int64 |\r\n| contentSizeInKb | DocumentRecord->Content_SizeInKb | number | decimal |\r\n| contentSizeInMb | DocumentRecord->Content_SizeInMb | number | decimal |\r\n| contentVersion | DocumentRecord->ContentVersion | integer | int32 |\r\n| fileFullName | DocumentRecord->FileFullName | string |  |\r\n| fileName | DocumentRecord->FileName | string |  |\r\n| fileTypeId | DocumentRecord->FileType_Id | integer | int64 |\r\n| fileTypeExtension | DocumentRecord->FileType_Extension | string |  |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| notes | DocumentRecord->Notes | string |  |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n",
        "operationId": "GetDocumentRecord",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Record",
            "schema": {
              "$ref": "#/definitions/GetDocumentRecordResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Update an existing Document Record resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| code | DocumentRecord->Code | string |  |\r\n| description | DocumentRecord->Description | string |  |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| notes | DocumentRecord->Notes | string |  |\r\n| fileName | DocumentRecord->FileName | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| revisionNumber | Nullable | False |  |\r\n| revisionDate | Nullable | False |  |\r\n| revisedBy | Nullable | False |  |\r\n| isApproved | Nullable | False |  |\r\n| documentFolderId | Nullable | False |  |\r\n| fileName | Nullable | False |  |\r\n\r\n",
        "operationId": "UpdateDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Document Record"
        ],
        "summary": "Delete an existing Document Record resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Get a collection of Document Record resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| code | DocumentRecord->Code | string |  |\r\n| description | DocumentRecord->Description | string |  |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| approvedByUserId | DocumentRecord->ApprovedByUser_Id | integer | int64 |\r\n| approvedByUserFullName | DocumentRecord->ApprovedByUser_FullName | string |  |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| fileFullName | DocumentRecord->FileFullName | string |  |\r\n| contentSizeInMb | DocumentRecord->Content_SizeInMb | number | decimal |\r\n| fileTypeExtension | DocumentRecord->FileType_Extension | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| documentFolderDescription | DocumentRecord->DocumentFolder_Description | string |  |\r\n| notes | DocumentRecord->Notes | string |  |\r\n| createdOn | DocumentRecord->CreatedOn | string | date-time |\r\n| modifiedOn | DocumentRecord->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetDocumentRecordCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Document Record collection",
            "schema": {
              "$ref": "#/definitions/GetDocumentRecordCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Document Record"
        ],
        "summary": "Create a new Document Record resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n| code | DocumentRecord->Code | string |  |\r\n| description | DocumentRecord->Description | string |  |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| notes | DocumentRecord->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| revisionNumber | Required | True |  |\r\n| revisionNumber | Nullable | False |  |\r\n| revisionDate | Required | True |  |\r\n| revisionDate | Nullable | False |  |\r\n| revisedBy | Required | True |  |\r\n| revisedBy | Nullable | False |  |\r\n| isApproved | Nullable | False |  |\r\n| documentFolderId | Required | True |  |\r\n| documentFolderId | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Lookups/LookupDocumentRecordChangePermissionTree": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Lookup the permission set for changing the Document Record.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupDocumentRecordChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/DocumentRecordChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Lookups/LookupDocumentRecordDocumentFolder": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Lookup the Document Folder for the Document Record.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentFolder->Id | integer | int64 |\r\n| description | DocumentFolder->Description | string |  |\r\n",
        "operationId": "LookupDocumentRecordDocumentFolder",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Document Folder collection",
            "schema": {
              "$ref": "#/definitions/DocumentRecordDocumentFolderLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Lookups/LookupDocumentRecordInsertPermissionTree": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Lookup the permission set for creating the Document Record.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupDocumentRecordInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/DocumentRecordInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Batch/{ids}": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Get a collection of Document Record resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | DocumentRecord->Code | string |  |\r\n| isActive | DocumentRecord->IsActive | boolean |  |\r\n| createdByUserId | DocumentRecord->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | DocumentRecord->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | DocumentRecord->CreatedByUser_FullName | string |  |\r\n| createdOn | DocumentRecord->CreatedOn | string | date-time |\r\n| modifiedByUserId | DocumentRecord->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | DocumentRecord->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | DocumentRecord->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | DocumentRecord->ModifiedOn | string | date-time |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | DocumentRecord->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | DocumentRecord->PermissionTree_Description | string |  |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| approvedByUserId | DocumentRecord->ApprovedByUser_Id | integer | int64 |\r\n| approvedByUserCode | DocumentRecord->ApprovedByUser_Code | string |  |\r\n| approvedByUserFullName | DocumentRecord->ApprovedByUser_FullName | string |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| description | DocumentRecord->Description | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| documentFolderDescription | DocumentRecord->DocumentFolder_Description | string |  |\r\n| fileInfoId | DocumentRecord->FileInfoId | integer | int64 |\r\n| bytes | DocumentRecord->Bytes | array | array |\r\n| contentId | DocumentRecord->Content_Id | integer | int64 |\r\n| contentFileLocationId | DocumentRecord->Content_FileLocation_Id | integer | int64 |\r\n| contentFileLocationDescription | DocumentRecord->Content_FileLocation_Description | string |  |\r\n| contentFileLocationFileLocationType | DocumentRecord->Content_FileLocation_FileLocationType | string (Allowed values: [FileSystem, Database]) | enum |\r\n| contentFileLocationOnKeyFileStoreId | DocumentRecord->Content_FileLocation_OnKeyFileStoreId | string | uuid |\r\n| contentSizeInBytes | DocumentRecord->Content_SizeInBytes | integer | int64 |\r\n| contentSizeInKb | DocumentRecord->Content_SizeInKb | number | decimal |\r\n| contentSizeInMb | DocumentRecord->Content_SizeInMb | number | decimal |\r\n| contentVersion | DocumentRecord->ContentVersion | integer | int32 |\r\n| fileFullName | DocumentRecord->FileFullName | string |  |\r\n| fileName | DocumentRecord->FileName | string |  |\r\n| fileTypeId | DocumentRecord->FileType_Id | integer | int64 |\r\n| fileTypeExtension | DocumentRecord->FileType_Extension | string |  |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| notes | DocumentRecord->Notes | string |  |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n",
        "operationId": "BatchGetDocumentRecord",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Document Record id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Record collection",
            "schema": {
              "$ref": "#/definitions/BatchGetDocumentRecordResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/FileContentHistory": {
      "get": {
        "tags": [
          "Document Record"
        ],
        "summary": "Get a collection of Document Record File History resources for the Document Record File History.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecordFileHistory->Id | integer | int64 |\r\n| version | DocumentRecordFileHistory->Version | integer | int32 |\r\n| contentId | DocumentRecordFileHistory->Content_Id | integer | int64 |\r\n| contentFileLocationId | DocumentRecordFileHistory->Content_FileLocation_Id | integer | int64 |\r\n| contentFileLocationDescription | DocumentRecordFileHistory->Content_FileLocation_Description | string |  |\r\n| contentFileLocationFileLocationType | DocumentRecordFileHistory->Content_FileLocation_FileLocationType | string (Allowed values: [FileSystem, Database]) | enum |\r\n| contentFileLocationOnKeyFileStoreId | DocumentRecordFileHistory->Content_FileLocation_OnKeyFileStoreId | string | uuid |\r\n| contentSizeInBytes | DocumentRecordFileHistory->Content_SizeInBytes | integer | int64 |\r\n| contentSizeInKb | DocumentRecordFileHistory->Content_SizeInKb | number | decimal |\r\n| contentSizeInMb | DocumentRecordFileHistory->Content_SizeInMb | number | decimal |\r\n| contentVersion | DocumentRecordFileHistory->ContentVersion | integer | int32 |\r\n| createdOn | DocumentRecordFileHistory->CreatedOn | string | date-time |\r\n| documentRecordId | DocumentRecordFileHistory->DocumentRecord_Id | integer | int64 |\r\n| documentRecordCode | DocumentRecordFileHistory->DocumentRecord_Code | string |  |\r\n| documentRecordDescription | DocumentRecordFileHistory->DocumentRecord_Description | string |  |\r\n",
        "operationId": "GetDocumentRecordFileHistory",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Record collection",
            "schema": {
              "$ref": "#/definitions/GetDocumentRecordFileHistoryResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Batch": {
      "post": {
        "tags": [
          "Document Record"
        ],
        "summary": "Create a new collection of Document Record resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n| code | DocumentRecord->Code | string |  |\r\n| description | DocumentRecord->Description | string |  |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| notes | DocumentRecord->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| revisionNumber | Required | True |  |\r\n| revisionNumber | Nullable | False |  |\r\n| revisionDate | Required | True |  |\r\n| revisionDate | Nullable | False |  |\r\n| revisedBy | Required | True |  |\r\n| revisedBy | Nullable | False |  |\r\n| isApproved | Nullable | False |  |\r\n| documentFolderId | Required | True |  |\r\n| documentFolderId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Document Record batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Update a collection of existing Document Record resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| code | DocumentRecord->Code | string |  |\r\n| description | DocumentRecord->Description | string |  |\r\n| revisionNumber | DocumentRecord->RevisionNumber | integer | int32 |\r\n| revisionDate | DocumentRecord->RevisionDate | string | date-time |\r\n| revisedBy | DocumentRecord->RevisedBy | string |  |\r\n| isApproved | DocumentRecord->IsApproved | boolean |  |\r\n| approvedFrom | DocumentRecord->ApprovedFrom | string | date-time |\r\n| approvedTo | DocumentRecord->ApprovedTo | string | date-time |\r\n| fileLocation | DocumentRecord->FileLocation | string |  |\r\n| documentFolderId | DocumentRecord->DocumentFolder_Id | integer | int64 |\r\n| notes | DocumentRecord->Notes | string |  |\r\n| fileName | DocumentRecord->FileName | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| revisionNumber | Nullable | False |  |\r\n| revisionDate | Nullable | False |  |\r\n| revisedBy | Nullable | False |  |\r\n| isApproved | Nullable | False |  |\r\n| documentFolderId | Nullable | False |  |\r\n| fileName | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchUpdateDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Document Record"
        ],
        "summary": "Delete a collection of existing Document Record resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteDocumentRecord",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteDocumentRecordResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/Active": {
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Change the IsActive status for an existing Document Record resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| isActive | DocumentRecord->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeDocumentRecordIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeDocumentRecordIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Change the PermissionTree for an existing Document Record resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeDocumentRecordPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeDocumentRecordPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/RemoveFile": {
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Document Record",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "RemoveDocumentRecordFile",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/RemoveDocumentRecordFileResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{id}/UploadFile": {
      "put": {
        "tags": [
          "Document Record"
        ],
        "summary": "Document Record",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| fileName | DocumentRecord->FileName | string |  |\r\n| bytes | DocumentRecord->Bytes | array | array |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| fileName | Nullable | False |  |\r\n\r\n",
        "operationId": "UploadDocumentRecordFile",
        "consumes": [
          "multipart/form-data"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "entityFilePatch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UploadDocumentRecordFileResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Batch/Active": {
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Change the IsActive status for a collection of existing Document Record resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| isActive | DocumentRecord->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeDocumentRecordIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeDocumentRecordIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Document Record"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Document Record resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecord->Id | integer | int64 |\r\n| version | DocumentRecord->Version | integer | int32 |\r\n| permissionTreeId | DocumentRecord->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeDocumentRecordPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeDocumentRecordPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/Attributes/{id}": {
      "get": {
        "tags": [
          "Document Record Attribute"
        ],
        "summary": "Get a Document Record Attribute resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| documentRecordId | DocumentRecordAttribute->DocumentRecord_Id | integer | int64 |\r\n| documentRecordCode | DocumentRecordAttribute->DocumentRecord_Code | string |  |\r\n| documentRecordDescription | DocumentRecordAttribute->DocumentRecord_Description | string |  |\r\n| createdByUserId | DocumentRecordAttribute->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | DocumentRecordAttribute->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | DocumentRecordAttribute->CreatedByUser_FullName | string |  |\r\n| createdOn | DocumentRecordAttribute->CreatedOn | string | date-time |\r\n| isActive | DocumentRecordAttribute->IsActive | boolean |  |\r\n| modifiedByUserId | DocumentRecordAttribute->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | DocumentRecordAttribute->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | DocumentRecordAttribute->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | DocumentRecordAttribute->ModifiedOn | string | date-time |\r\n| permissionTreeId | DocumentRecordAttribute->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | DocumentRecordAttribute->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | DocumentRecordAttribute->PermissionTree_Description | string |  |\r\n| version | DocumentRecordAttribute->Version | integer | int32 |\r\n| id | DocumentRecordAttribute->Id | integer | int64 |\r\n| attributeId | DocumentRecordAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | DocumentRecordAttribute->Attribute_Code | string |  |\r\n| attributeDescription | DocumentRecordAttribute->Attribute_Description | string |  |\r\n| attributeAllowAnyValue | DocumentRecordAttribute->Attribute_AllowAnyValue | boolean |  |\r\n| attributeDataType | DocumentRecordAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| attributeDefaultValue | DocumentRecordAttribute->Attribute_DefaultValue | object | composite |\r\n| attributeDefaultAllowedValueId | DocumentRecordAttribute->Attribute_DefaultAllowedValue_Id | integer | int64 |\r\n| attributeDefaultAllowedValueDescription | DocumentRecordAttribute->Attribute_DefaultAllowedValue_Description | string |  |\r\n| attributeDefaultAllowedValueValue | DocumentRecordAttribute->Attribute_DefaultAllowedValue_Value | object | composite |\r\n| notes | DocumentRecordAttribute->Notes | string |  |\r\n| predefinedValueId | DocumentRecordAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | DocumentRecordAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | DocumentRecordAttribute->PredefinedValue_Value | object | composite |\r\n| sequenceNumber | DocumentRecordAttribute->SequenceNumber | integer | int32 |\r\n| value | DocumentRecordAttribute->Value | object | composite |\r\n",
        "operationId": "GetDocumentRecordAttribute",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Document Record Attribute",
            "schema": {
              "$ref": "#/definitions/GetDocumentRecordAttributeResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Document Record Attribute"
        ],
        "summary": "Update an existing Document Record Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecordAttribute->Version | integer | int32 |\r\n| value | DocumentRecordAttribute->Value | object | composite |\r\n| predefinedValueId | DocumentRecordAttribute->PredefinedValue_Id | integer | int64 |\r\n| sequenceNumber | DocumentRecordAttribute->SequenceNumber | integer | int32 |\r\n| notes | DocumentRecordAttribute->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| value | Nullable | True |  |\r\n| predefinedValueId | Nullable | True |  |\r\n\r\n",
        "operationId": "UpdateDocumentRecordAttribute",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateDocumentRecordAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record Attribute was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Document Record Attribute"
        ],
        "summary": "Delete an existing Document Record Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | DocumentRecordAttribute->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteDocumentRecordAttribute",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Document Record Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteDocumentRecordAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Document Record Attribute was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/DM/DocumentRecords/{documentRecordId}/Attributes": {
      "get": {
        "tags": [
          "Document Record Attribute"
        ],
        "summary": "Get a collection of Document Record Attribute resources for the Document Record.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | DocumentRecordAttribute->Id | integer | int64 |\r\n| version | DocumentRecordAttribute->Version | integer | int32 |\r\n| sequenceNumber | DocumentRecordAttribute->SequenceNumber | integer | int32 |\r\n| attributeId | DocumentRecordAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | DocumentRecordAttribute->Attribute_Code | string |  |\r\n| attributeDescription | DocumentRecordAttribute->Attribute_Description | string |  |\r\n| attributeDataType | DocumentRecordAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| predefinedValueId | DocumentRecordAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | DocumentRecordAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | DocumentRecordAttribute->PredefinedValue_Value | object | composite |\r\n| value | DocumentRecordAttribute->Value | object | composite |\r\n| notes | DocumentRecordAttribute->Notes | string |  |\r\n| createdOn | DocumentRecordAttribute->CreatedOn | string | date-time |\r\n| modifiedOn | DocumentRecordAttribute->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetDocumentRecordAttributeCollectionForDocumentRecord",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "documentRecordId",
            "in": "path",
[...]
